﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.IO;

public partial class Default2 : System.Web.UI.Page
{
    
    #region Event
    protected void Button1_Click(object sender, EventArgs e)
    {
        //Open the document
        WordDocument document = new WordDocument(Server.MapPath("App_Data/document.doc"));
        //Get the input text file
        FileStream fs = new FileStream(Server.MapPath("App_Data/data.txt"), FileMode.Open, FileAccess.Read);
        StreamReader sr = new StreamReader(fs);

        //Read each line of text file
        String readString = sr.ReadLine();
        while (readString != null)
        {
            //replace corresponding merge field with value
            document.ReplaceMergeField(readString.Split('-')[0], readString.Split('-')[1]);
            readString = sr.ReadLine();
        }
               
        //Save the document
        if (rdButtonWord97To2003.Checked)
            document.Save("Sample.doc", FormatType.Doc, Response, HttpContentDisposition.Attachment);
        else if (rdButtonWord2007.Checked)
            document.Save("Sample.docx", FormatType.Docx, Response, HttpContentDisposition.Attachment);
        else if (rdButtonWord2010.Checked)
            document.Save("Sample.docx", FormatType.Word2010, Response, HttpContentDisposition.Attachment);

    }
    #endregion

}

#region ExtendedClass
public static class DocIOExtensions
{

    public static void ReplaceMergeField(this WordDocument document,String mergeFieldName,String replaceString)
    {
        foreach (var item in document.Visit())
        {
            //If the entity is merge field
            if (item.EntityType == EntityType.MergeField)
            {
                WMergeField field = (WMergeField)item;
                //Check the merge filed name.
                if (field.FieldName.Trim() == mergeFieldName.Trim())
                {
                    //create a text range with value to replace
                    WTextRange wr = new WTextRange(document);
                    wr.Text = replaceString;
                    WParagraph para = field.OwnerParagraph;
                    //get the index of merge filed
                    int currentIndex = para.ChildEntities.IndexOf(item);
                    //remove the merge filed
                    para.ChildEntities.Remove(item);
                    //insert the textrange at index of merge field
                    para.ChildEntities.Insert(currentIndex, wr);

                }
            }
        }
    }
    
    public static IEnumerable<IEntity> Visit(this ICompositeEntity entity)
    {
        var entities = new Stack<IEntity>(new IEntity[] { entity });
        while (entities.Count > 0)
        {
            var e = entities.Pop();
            yield return e;
            if (e is ICompositeEntity)
            {
                foreach (IEntity childEntity in ((ICompositeEntity)e).ChildEntities)
                {
                    entities.Push(childEntity);
                }
            }
        }
    }
}
#endregion